//+------------------------------------------------------------------+
//|                                                      CrossMa.mq5 |
//+------------------------------------------------------------------+
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"
#property version   "1.00"
//---      
#property indicator_chart_window
//---  
#property indicator_buffers 2
#property indicator_plots   1
//--- plot 1
#property indicator_type1   DRAW_FILLING
#property indicator_color1  clrRed, clrBlue
//---  
input int MaFast=5;  //   MA
input int MaSlow=20; //   MA
//---  
double Fast[];
double Slow[];
//---  
int    FastHandle;
int    SlowHandle;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//---   
   SetIndexBuffer(0,Fast,INDICATOR_DATA);
   SetIndexBuffer(1,Slow,INDICATOR_DATA);
//---   
   FastHandle=iMA(NULL,0,MaFast,0,MODE_EMA,PRICE_CLOSE);
   SlowHandle=iMA(NULL,0,MaSlow,0,MODE_EMA,PRICE_CLOSE);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---     
   int start=prev_calculated;
//---   ,      
   if(start>0)
      start--;
//---      
   if(start<rates_total)
     {
      //---   MA   
      CopyBuffer(FastHandle,0,0,rates_total-start,Fast);
      CopyBuffer(SlowHandle,0,0,rates_total-start,Slow);
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
