//+------------------------------------------------------------------+
//|                                                   BarsSample.mq5 |
//+------------------------------------------------------------------+
#property copyright "TheXpert"
#property link      "TheForEXpert@gmail.com"
#property version   "1.00"
//---     
#property indicator_separate_window
//---  
#property indicator_buffers 4
#property indicator_plots   1
//--- plot 1
#property indicator_type1  DRAW_BARS
#property indicator_color1 clrGray
//---  
double O[];
double H[];
double L[];
double C[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//---   
   SetIndexBuffer(0,O,INDICATOR_DATA);
   SetIndexBuffer(1,H,INDICATOR_DATA);
   SetIndexBuffer(2,L,INDICATOR_DATA);
   SetIndexBuffer(3,C,INDICATOR_DATA);
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---     
   int start=prev_calculated;
//---   ,      
   if(start>0)
      start--;
//---      
   if(start<rates_total)
     {
      //---      
      ArrayCopy(O,open,start,start);
      ArrayCopy(H,high,start,start);
      ArrayCopy(L,low,start,start);
      ArrayCopy(C,close,start,start);
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
